scala.tools.nsc.transform.LazyVals

# LazyValues

#### class LazyValues extends TypingTransformer

Transform local lazy accessors to check for the initialized bit.

Linear Supertypes
LazyVals.TypingTransformer, Global.Transformer, Global.Transformer, AnyRef, Any
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. LazyValues
2. TypingTransformer
3. Transformer
4. Transformer
5. AnyRef
6. Any

Implicitly

1. by any2stringadd
2. by any2stringfmt
3. by any2ArrowAssoc
4. by any2Ensuring

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Instance Constructors

1. #### new LazyValues(unit: Global.CompilationUnit)

### Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Definition Classes
     Any

3. #### final def ##(): Int

   Definition Classes
     AnyRef → Any

4. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from LazyValues to StringAdd performed by method any2stringadd in scala.Predef.
   Definition Classes
     StringAdd

5. #### def ->[B](y: B): (LazyValues, B)

   Implicit information
     This member is added by an implicit conversion from LazyValues to ArrowAssoc[LazyValues] performed by method any2ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

6. #### final def ==(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

7. #### final def ==(arg0: Any): Boolean

   Definition Classes
     Any

8. #### final def asInstanceOf[T0]: T0

   Definition Classes
     Any

9. #### def atOwner[A](tree: Global.Tree, owner: Global.Symbol)(trans: ⇒ A): A

   Definition Classes
     TypingTransformer

10. #### final def atOwner[A](owner: Global.Symbol)(trans: ⇒ A): A

    Definition Classes
      TypingTransformer → Transformer

11. #### val bitmaps: Map[Global.Symbol, collection.immutable.List[Global.Symbol]]

12. #### def clone(): AnyRef

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

13. #### var curTree: Global.Tree

    Attributes
      protected
    Definition Classes
      TypingTransformer

14. #### def currentClass: Global.Symbol

    Attributes
      protected
    Definition Classes
      Transformer

15. #### def currentMethod: Global.Symbol

    Attributes
      protected
    Definition Classes
      Transformer

16. #### var currentOwner: Global.Symbol

    Attributes
      protected[scala]
    Definition Classes
      Transformer

17. #### def ensuring(cond: (LazyValues) ⇒ Boolean, msg: ⇒ Any): LazyValues

    Implicit information
      This member is added by an implicit conversion from LazyValues to Ensuring[LazyValues] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

18. #### def ensuring(cond: (LazyValues) ⇒ Boolean): LazyValues

    Implicit information
      This member is added by an implicit conversion from LazyValues to Ensuring[LazyValues] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

19. #### def ensuring(cond: Boolean, msg: ⇒ Any): LazyValues

    Implicit information
      This member is added by an implicit conversion from LazyValues to Ensuring[LazyValues] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

20. #### def ensuring(cond: Boolean): LazyValues

    Implicit information
      This member is added by an implicit conversion from LazyValues to Ensuring[LazyValues] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

21. #### final def eq(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

22. #### def equals(arg0: Any): Boolean

    Definition Classes
      AnyRef → Any

23. #### def finalize(): Unit

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )

24. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from LazyValues to StringFormat performed by method any2stringfmt in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

25. #### final def getClass(): Class[_]

    Definition Classes
      AnyRef → Any

26. #### def hashCode(): Int

    Definition Classes
      AnyRef → Any

27. #### final def isInstanceOf[T0]: Boolean

    Definition Classes
      Any

28. #### var localTyper: (analyzer)#Typer

    Definition Classes
      TypingTransformer

29. #### def mkFastPathBody(clazz: Global.Symbol, lzyVal: Global.Symbol, cond: Global.Tree, syncBody: List[Global.Tree], stats: List[Global.Tree], retVal: Global.Tree): (Global.Tree, Global.Tree)

30. #### def mkSlowPathDef(clazz: Global.Symbol, lzyVal: Global.Symbol, cond: Global.Tree, syncBody: List[Global.Tree], stats: List[Global.Tree], retVal: Global.Tree): Global.Tree

31. #### final def ne(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

32. #### final def notify(): Unit

    Definition Classes
      AnyRef

33. #### final def notifyAll(): Unit

    Definition Classes
      AnyRef

34. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

35. #### def toString(): String

    Definition Classes
      AnyRef → Any

36. #### def transform(tree: Global.Tree): Global.Tree

    Perform the following transformations:

    Perform the following transformations:

    - for a lazy accessor inside a method, make it check the initialization bitmap
    - for all methods, add enough int vars to allow one flag per lazy local value
    - blocks in template bodies behave almost like methods. A single bitmaps section is added in the first block, for all lazy values defined in such blocks.
    - remove ACCESSOR flags: accessors in traits are not statically implemented, but moved to the host class. local lazy values should be statically implemented.
    Definition Classes
      LazyValues → TypingTransformer → Transformer

37. #### def transformCaseDefs(trees: List[Global.CaseDef]): List[Global.CaseDef]

    Definition Classes
      Transformer

38. #### def transformIdents(trees: List[Global.Ident]): List[Global.Ident]

    Definition Classes
      Transformer

39. #### def transformModifiers(mods: Global.Modifiers): Global.Modifiers

    Definition Classes
      Transformer

40. #### def transformStats(stats: List[Global.Tree], exprOwner: Global.Symbol): List[Global.Tree]

    Definition Classes
      Transformer

41. #### def transformTemplate(tree: Global.Template): Global.Template

    Definition Classes
      Transformer

42. #### def transformTrees(trees: List[Global.Tree]): List[Global.Tree]

    Definition Classes
      Transformer

43. #### def transformTypeDefs(trees: List[Global.TypeDef]): List[Global.TypeDef]

    Definition Classes
      Transformer

44. #### def transformUnit(unit: Global.CompilationUnit): Unit

    Definition Classes
      Transformer

45. #### def transformValDef(tree: Global.ValDef): Global.ValDef

    Definition Classes
      Transformer

46. #### def transformValDefs(trees: List[Global.ValDef]): List[Global.ValDef]

    Definition Classes
      Transformer

47. #### def transformValDefss(treess: List[List[Global.ValDef]]): List[List[Global.ValDef]]

    Definition Classes
      Transformer

48. #### val treeCopy: Global.TreeCopier

    Definition Classes
      Transformer

49. #### def typedPos(pos: Global.Position)(tree: Global.Tree): Global.Tree

    Attributes
      protected
    Definition Classes
      TypingTransformer

50. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

51. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

52. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

53. #### def →[B](y: B): (LazyValues, B)

    Implicit information
      This member is added by an implicit conversion from LazyValues to ArrowAssoc[LazyValues] performed by method any2ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Shadowed Implicit Value Members

1. #### val self: Any

   Implicit information
     This member is added by an implicit conversion from LazyValues to StringAdd performed by method any2stringadd in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (lazyValues: StringAdd).self

   Definition Classes
     StringAdd

2. #### val self: Any

   Implicit information
     This member is added by an implicit conversion from LazyValues to StringFormat performed by method any2stringfmt in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (lazyValues: StringFormat).self

   Definition Classes
     StringFormat

### Deprecated Value Members

1. #### def x: LazyValues

   Implicit information
     This member is added by an implicit conversion from LazyValues to ArrowAssoc[LazyValues] performed by method any2ArrowAssoc in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (lazyValues: ArrowAssoc[LazyValues]).x

   Definition Classes
     ArrowAssoc
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) Use `leftOfArrow`instead``

2. #### def x: LazyValues

   Implicit information
     This member is added by an implicit conversion from LazyValues to Ensuring[LazyValues] performed by method any2Ensuring in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (lazyValues: Ensuring[LazyValues]).x

   Definition Classes
     Ensuring
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) Use `resultOfEnsuring`instead``

### Inherited from LazyVals.TypingTransformer

### Inherited from Global.Transformer

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from LazyValues to StringAdd

### Inherited by implicit conversion any2stringfmt from LazyValues to StringFormat

### Inherited by implicit conversion any2ArrowAssoc from LazyValues to ArrowAssoc[LazyValues]

### Inherited by implicit conversion any2Ensuring from LazyValues to Ensuring[LazyValues]

### Ungrouped